<?php
/*
 * API
 *
 * 修改用户当前的代拨帐号接口
 *
 */
namespace raas\apps\account;

$appdir = dirname(dirname(__FILE__));
$appname = basename($appdir);
$appmethod = basename(__FILE__, '.php');

// $token = $appname . '_' . $appmethod;


// 支持库装载 | load lib
// ni_library_load('nidb');

// 装载功能 | load function
ni_app_load('user', 'login');
ni_app_load('account', 'info');
ni_app_load('enterpise', 'find');
ni_app_load('account', 'isp');
ni_app_load('enterpise', 'isp');

if(isset($_REQUEST['domain']) == false || ($domain = trim($_REQUEST['domain'])) == '') 
	json_error_exit(ERR_FAILURE, 'ARG');

if(isset($_REQUEST['account']) == false || ($account = trim($_REQUEST['account'])) == '') 
	json_error_exit(ERR_FAILURE, 'ARG');

if(isset($_REQUEST['pass']) == false || ($pass = trim($_REQUEST['pass'])) == '')
	json_error_exit(ERR_FAILURE, 'ARG');

if(isset($_REQUEST['isp_id']) == false 
|| ($isp_id = intval($_REQUEST['isp_id'])) <= 0) {
	$isp_id = 0;
	$pxyacct = '';
}
else
if(isset($_REQUEST['pxyacct']) == false 
|| ($pxyacct = trim($_REQUEST['pxyacct'])) == '') {
	$isp_id = 0;
	$pxyacct = '';
}

if(isset($_REQUEST['charset']) == 'GB2312') {
	$account = iconv('GB2312', 'UTF-8', $account);
	$_REQUEST['account'] = $account;
}

if(($ent = \raas\apps\enterpise\_finddomain($domain)) === false){
	json_error_exit(2, 'NENT');
}

$frmData = array(
	'ent_id' => $ent->ent_id,
	'account' => $account,
);

if(($acct = \raas\apps\account\info($frmData, 1)) === false) {
	json_error_exit(3, 'INV_USER_OR_PASS');
}
if($acct->pass != $pass)
	json_error_exit(4, 'INV_USER_OR_PASS');

if($pxyacct != '') {
	$frmData = array (
		'own_id' => $ent->own_id,
		'acct_id' => $acct->acct_id,
		'isp_id' => $isp_id,
		'acct'	=> $pxyacct,
	);
	if(($ispinfo = \raas\apps\enterpise\isp\info($frmData)) === false) {
		json_error_exit(5, 'NOT_ISP');
	}
	if(($pxyinfo = \raas\apps\account\isp\info($frmData)) === false) {
		json_error_exit(6, 'NPXYACCT');
	}
	$ippool		= $ispinfo->ippool;
	$pxypass	= $pxyinfo->pass;

	$pxyvlan_in = ($pxyinfo->pxyvlan_in > 0 ? $pxyinfo->pxyvlan_in: $ispinfo->vlan_in);
	$pxyvlan_out= ($pxyinfo->pxyvlan_out > 0 ? $pxyinfo->pxyvlan_out: $ispinfo->vlan_out);
}
else {
	$ippool		= '';
	$pxypass	= '';
	$pxyvlan_in = '';
	$pxyvlan_out= '';
}

// 获取帐号列表
$frmData = array(
	'own_id'    => $ent->own_id,
	'acct_id'   => $acct->acct_id,
	'ippool'    => $ippool,
	'isp_id'    => $isp_id,
	'pxyacct'	=> $pxyacct,
	'pxypass'	=> $pxypass,
	'pxyvlan_in'=> $pxyvlan_in,
	'pxyvlan_out'=> $pxyvlan_out,
);
if(($resut = \raas\apps\account\isp\api_save($frmData)) === false) {
	json_error_exit(7, 'ERRSAVE');
}

json_error_exit(ERR_OK, 'OK', $resut);
