<?php
namespace raas\apps\account;


ni_app_load('account', 'list');
require_once(__DIR__ . '/logger/modify.php');

function bat_expire_time($data)
{
	global $nidb, $user;

	$values = array();
	$optional = array();

	if(isset($data['v_expire_time']) == false || $data['v_expire_time'] == '') {
		set_errmsg(MSG_LEVEL_EXP, __function__, '请输入到期时间。');
		return false;
	}

	try {
		$v_expire_time = new \DateTime($data['v_expire_time']);
		$expire_time = $v_expire_time->getTimestamp();
		$str_expire_time = date('Y-m-d H:i:s', $expire_time);
	} catch (Exception $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, '到期时间正确。');
		return false;
	}
		
	$where_str = getsqlstr_where($data, $values, $optional);

	$logger = array(
		'user_id'	=> $user->user_id,
		'username'	=> $user->name,
		'action'	=> 'modify_acct_expire_time',
		'data'		=> json_encode($optional),
		'create_time'=> time()
	);

	$sql = "select * from cloud_account {$where_str}";

	try {
		$sth = $nidb->prepare($sql);
	 	$ret = $sth->execute($values);
		// $sth->setAttribute(\PDO::FETCH_ASSOC);
		while (($info = $sth->fetch(\PDO::FETCH_ASSOC, \PDO::FETCH_ORI_NEXT))) {
			// 添加操作日志
			$logger['own_id'] = $info['own_id'];
			$logger['ent_id'] = $info['ent_id'];
			$logger['acct_id'] = $info['acct_id'];
			$logger['account'] = $info['account'];
			$logger['remark'] = '帐号=' . $info['account'] . '，姓名=' . $info['name'];
			$logger['remark'].= '，到期时间=' . $str_expire_time;

			\raas\apps\account\logger\modify\_create($logger);

			$info['expire_time'] = $expire_time;
			raaseye_acct_add($info);
		}
		$sth = null;
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}
	
	$sql = "update cloud_account set `expire_time` = {$expire_time} {$where_str}";

	try {
		$sth = $nidb->prepare($sql);
	 	$ret = $sth->execute($values);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	return $ret;
}

