<?php
namespace raas\apps\account;


ni_app_load('account', 'info');
require_once(__DIR__ . '/logger/modify.php');

function disable($data)
{
	global $nidb, $user;

	$filter = array(
		'acct_id'	=> new \FilterVarID(true),
		'ent_id'	=> new \FilterVarID(true),
		'own_id'	=> new \FilterVarID(true),
	);
	if(($where = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}

	$frmData['disabled'] = 1;
	$frmData['update_time'] = time();

	try {
		if(update_data('cloud_account', $frmData, $where) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			return false;
		}
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}


//	synclog_push(RA_SYNC_ACCOUNT, $where['acct_id']);
	$info = info($where, 1);

	// 添加操作日志
	$logger = array(
		'own_id'	=> $info['own_id'],
		'ent_id'	=> 0,
		'user_id'	=> $where['acct_id'],
		'acct_id'	=> $info['acct_id'],
		'account'	=> $info['account'],
		'username'	=> '',
		'action'	=> 'disable_acct',
		'data'		=> '',
		'remark'	=> '帐号=' . $info['account'] . '，姓名=' . $info['name'],
		'create_time'=> time()
	);
	if($user !== false && $user !== NULL) {
		$logger['user_id'] = $user->user_id;
		$logger['username'] = $user->name;
	}

	$logger['data'] = json_encode($info['data']);
	if(isset($info['phone']) && $info['phone'] != '')
		$logger['remark'].= '，联系电话=' . $info['phone'];

	\raas\apps\account\logger\modify\_create($logger);

	raaseye_acct_add($info);

	return true;
}

