<?php
namespace raas\apps\account;


ni_app_load('account', 'info');
require_once(__DIR__ . '/logger/modify.php');

function kick($data)
{
	global $nidb, $user;

	$optional = array();

	// set custom options
	if(format_and_push($data, 'nasip', $optional, '', 'string', false) == false){
		set_errmsg(MSG_LEVEL_ARG, __function__, 'acct can\'t empty.');
		return false;
	}
	if(format_and_push($data, 'session', $optional, '', 'string', false) == false){
		set_errmsg(MSG_LEVEL_ARG, __function__, 'session can\'t empty.');
		return false;
	}
	
	$nasip = str_replace(
				array('&', '|', '\\', "`", "'", "#"), 
				array('', '',   '',  '', '', ''), 
				$optional['nasip']);
	$session = str_replace(
				array('&', '|', '\\', "`", "'", "#"), 
				array('', '',   '',  '', '', ''), 
				$optional['session']);

	$cmd = RAASEYE . " session remove nip={$nasip} sid={$session}";

	exec($cmd, $rows, $retval);
	//	$result['cmd'] = $cmd;
	if($retval != 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, implode(',', $rows));
		return false;
	}
	
	$where = array();
	// set custom options
	if(format_and_push($data, 'acct_id', $where, '', 'int', false) == false){
		set_errmsg(MSG_LEVEL_ARG, __function__, 'acct_id can\'t empty.');
		return false;
	}
	if(format_and_push($data, 'ent_id', $where, '', 'int', false) == false){
		set_errmsg(MSG_LEVEL_ARG, __function__, 'ent_id can\'t empty.');
		return false;
	}

	$info = info($where, 1);

	// 添加操作日志
	$logger = array(
		'own_id'	=> $info['own_id'],
		'ent_id'	=> $info['ent_id'],
		'user_id'	=> 0,
		'acct_id'	=> $info['acct_id'],
		'account'	=> $info['account'],
		'username'	=> '',
		'action'	=> 'disable_acct',
		'data'		=> '',
		'remark'	=> '帐号=' . $info['account'] . '，姓名=' . $info['name'],
		'create_time'=> time()
	);
	if($user !== false && $user !== NULL) {
		$logger['user_id'] = $user->user_id;
		$logger['username'] = $user->name;
	}

	$logger['data'] = json_encode($info['data']);
	if(isset($info['phone']) && $info['phone'] != '')
		$logger['remark'].= '，联系电话=' . $info['phone'];

	\raas\apps\account\logger\modify\_create($logger);

	return $rows;
}
