<?php
namespace raas\apps\account;

define( 'RAASEYE', '/paraas/bin/raaseye');


function FormatResultlst(array $keys, array $values)
{
	$result = array();
	
	$cnt = count($keys);
	
	foreach($values as $volume)
	{
		$volume = explode(' ', $volume);
		$vc = count($volume);

		if($vc < $cnt) 
			continue;
		
		$count = array_push($result, array_combine($keys, $volume));
		$id = $count - 1;
		$result[$id]['cname'] =  iconv('GB2312', 'UTF-8', $result[$id]['cname']);
		$result[$id]['card'] =  iconv('GB2312', 'UTF-8', $result[$id]['card']);
		$result[$id]['phone'] =  iconv('GB2312', 'UTF-8', $result[$id]['phone']);
		$result[$id]['other'] =  iconv('GB2312', 'UTF-8', $result[$id]['other']);
	}

	return $result;
}

function logger($data)
{
	global $nidb;

	$values = array();
	$optional = array();
	// set order, limit, offset value
	format_list_arg($data, $optional);

	$where_str = '';

	// set custom options
	if(format_and_push($data, 'own_id', $optional, '', 'int', false))
		$where_str .= " ownid=" . $optional['own_id'];
	
	if(format_and_push($data, 'ent_id', $optional, '', 'int', false))
		$where_str .= " entid=" . $optional['ent_id'];

	if(format_and_push($data, 'acct_id', $optional, '', 'int', false))
		$where_str .= " acctid=" . $optional['acct_id'];
	
	if(format_and_push($data, 'group_id', $optional, '', 'int', false))
		$where_str .= " gid=" . $optional['group_id'];
	
	if(format_and_push($data, 'acct', $optional, '', 'string', false)) {
		if(preg_match("/^([a-zA-Z0-9-_@.]{2,})$/", $optional['acct'], $match) == false) {
			set_errmsg(MSG_LEVEL_DEF, __function__, '帐号格式不正确！格式：xx@xx.xx');
			return false;
		}
		$where_str .= " acct=" . $optional['acct'];
	}
		


	if(isset($data['search'])) {
		if(format_and_push($data['search'], 'value', $optional, 'search', 'string', false)) {
			$grep_str = 'grep -E "' . str_replace(
				array('&', '|', '\\', "`", "'", "#"), 
				array('', '',   '',  '', '', ''), 
				$optional['search']) . '"';
		}
	}

	$result = array(
		'total'	=> 0,
		'rows'	=> array()
	);

	try {

		if(isset($grep_str))
			$cmd = RAASEYE . " logger list $where_str | $grep_str";
		else
			$cmd = RAASEYE . " logger list $where_str";
		$cmd .= "| awk '{if(r++>=" . $optional['offset'] . "){if(c++<" . $optional['limit'] . ")print $0;}}END{print r - 1;}' ";

		exec($cmd, $rows, $retval);

		//	$result['cmd'] = $cmd;
		if($retval == 0 && is_array($rows) === true) {
			$result['total']= intval(array_pop($rows));
			$result['rows'] = $rows; // FormatResultlst($keys, $rows);
		}
		
		$result['cmd'] = $cmd;
		$result['err'] = $rows;
		$result['retval'] = $retval;
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}


	if(isset($data['draw'])) $result['draw'] = $data['draw'];

	return $result;
}

function usagelogger($data)
{
	global $nidb, $user;

	$values = array();
	$optional = array();
	// set order, limit, offset value
	format_list_arg($data, $optional);

	$where_str = '';
	if(format_and_push($data, 'startm', $optional, '', 'int', false))
		$where_str .= "`create_time` >= " . $optional['startm'] . " and ";

	if(format_and_push($data, 'endtm', $optional, '', 'int', false))
		$where_str .= "`create_time` < " . $optional['endtm']  . " and ";

	// set custom options
	if(format_and_push($data, 'own_id', $optional, '', 'int', false))
		$where_str .= "`own_id` = " . $optional['own_id']  . " and ";
	
	if(format_and_push($data, 'ent_id', $optional, '', 'int', false))
		$where_str .= "`ent_id` = " . $optional['ent_id']  . " and ";

	if(format_and_push($data, 'acct_id', $optional, '', 'int', false))
		$where_str .= "`acct_id` = " . $optional['acct_id']  . " and ";
	
	if(format_and_push($data, 'group_id', $optional, '', 'int', false))
		$where_str .= "`group_id` = " . $optional['group_id']  . " and ";
	
	if(format_and_push($data, 'account', $optional, '', 'string', false)) {
		$where_str .= "`account` = ? and ";
		array_push($values, $optional['account']);
	}

	if(isset($data['search'])) {
		if(format_and_push($data['search'], 'value', $optional, 'search', 'string', false)) {
			$where_str .= "(`session_id` like ? or `event` like ?) and ";
			array_push($values, "%" . $optional['search'] . "%");
			array_push($values, "%" . $optional['search'] . "%");
		}
	}

	if($where_str != '')
		$where_str = substr("where $where_str", 0, -5);


	$order_map = array(
		"own_id",
		"ent_id",
		"group_id",
		"acct_id",
		"event",
		"ip",
		"mac",
		"session_id",
		"account",
		"name",
		"ent",
		"gorup",
		"tmlong",
		"event_time",
		"bpsin",
		"bpsout",
		"create_time",
	);

	$order = array();
	if(isset($optional['order'])) {
		foreach($optional['order'] as $op) {
			if(isset($op['column']) && isset($data['columns'][$op['column']]['data'])) {
				if(in_array($data['columns'][$op['column']]['data'], $order_map))
					array_push($order, "`" . $data['columns'][$op['column']]['data'] . "` " . $op['dir']);
			}
		}
	}

	if(count($order) > 0)
		$order_by = 'order by ' . implode(', ', $order);
	else
		$order_by = 'order by `create_time` desc';

	$sql = "select count(*) as `total` from cloud_account_usage_logger $where_str";

	try {
		$sth = $nidb->prepare($sql);
		$sth->execute($values);
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}
	
	if(count($rows) > 0) {
		$result = array(
			'total' => $rows[0]->total,
		);
	}
	else {
		$result = array(
			'total' => 0,
		);
	}

	$keys = '`acct_id`,
		`ent_id`,
		`own_id`,
		`group_id`,
		`event`,
		`ip`,
		`mac`,
		`session_id`,
		`account`,
		`name`,
		`ent`,
		`gorup`,
		`tmlong`,
		`event_time`,
		`bpsin`,
		`bpsout`,
		`create_time`';

	$sql = "select $keys from cloud_account_usage_logger $where_str $order_by limit ? offset ? ";

	array_push($values, $optional['limit']);
	array_push($values, $optional['offset']);


	try {
		$sth = $nidb->prepare($sql);
		$sth->execute($values);
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	$result['rows'] = $rows;

	if(isset($data['draw'])) $result['draw'] = $data['draw'];

	return $result;
}

