//用户趋势
function set_user_bar() {
	var myChart = echarts.init(document.getElementById('user-chart'));
	var option = {
		tooltip: {
			trigger: 'axis',
			axisPointer: {
				type: 'line'
			}
		},
		toolbox: {
			show: true,
			feature: {
				saveAsImage: {}
			}
		},
		grid: {
			left: '3%',
			right: '4%',
			bottom: '3%',
			containLabel: true
		},
		xAxis: {
			type: 'category',
			boundaryGap: false,
			data: ['00:00', '01:15', '02:30', '03:45', '05:00', '06:15', '07:30', '08:45', '10:00', '11:15', '12:30', '13:45',
				'15:00', '16:15', '17:30', '18:45', '20:00', '21:15', '22:30', '23:45'
			]
		},
		yAxis: {
			type: 'value',
			axisLabel: {
				formatter: '{value}'
			},
			axisPointer: {
				snap: true
			}
		},
		visualMap: {
			show: false,
			dimension: 0,
			pieces: [{
				lte: 6,
				color: 'green'
			}, {
				gt: 6,
				lte: 8,
				color: 'red'
			}, {
				gt: 8,
				lte: 14,
				color: 'green'
			}, {
				gt: 14,
				lte: 17,
				color: 'red'
			}, {
				gt: 17,
				color: 'green'
			}]
		},
		series: [{
			name: '在线用户',
			type: 'line',
			areaStyle: {
				color: '#bdd4fb'
			},
			itemStyle: {
				normal: {
					color: '#4285f4', //折点颜色
					lineStyle: {
						color: '#4285f4' //折线颜色
					}
				}
			},
			// smooth: true,
			data: [300, 280, 250, 260, 270, 300, 550, 500, 400, 390, 380, 390, 400, 500, 600, 750, 800, 700, 600, 400],
			markArea: {
				itemStyle: {
					color: 'rgba(255, 173, 177, 0.4)'
				}
			}
		}]
	}
	myChart.setOption(option);
}

//cpu使用率
function cpu_bar() {
	var myChart = echarts.init(document.getElementById('cpu-chart'));
	var option = {
		tooltip: {
			trigger: 'axis',
			axisPointer: {
				type: 'line',
				label: {
					backgroundColor: '#6a7985'
				}
			}
		},
		toolbox: {
			feature: {
				saveAsImage: {}
			}
		},
		grid: {
			left: '3%',
			right: '4%',
			bottom: '3%',
			containLabel: true
		},
		xAxis: [{
			type: 'category',
			boundaryGap: false,
			data: ['00:00', '01:15', '02:30', '03:45', '05:00', '06:15', '07:30', '08:45', '10:00', '11:15', '12:30', '13:45',
				'15:00', '16:15', '17:30', '18:45', '20:00', '21:15', '22:30', '23:45'
			]
		}],
		yAxis: [{
			type: 'value'
		}],
		series: [{
				name: '上行',
				type: 'line',
				smooth: true,
				areaStyle: {
					color: '#d6e4fd'
				},
				itemStyle: {
					normal: {
						color: '#bac6dc', //折点颜色
						lineStyle: {
							color: '#bac6dc' //折线颜色
						}
					}
				},
				emphasis: {
					focus: 'series'
				},
				data: [40, 50, 60, 80, 60, 40, 10, 70, 30, 50, 70, 50, 60, 50, 60, 50, 10, 50, 40, 30],
			},
			{
				name: '下行',
				type: 'line',
				smooth: true,
				label: {
					position: 'top'
				},
				areaStyle: {
					color: '#8bb4f8'
				},
				itemStyle: {
					normal: {
						color: '#4285f4', //折点颜色
						lineStyle: {
							color: '#4285f4' //折线颜色
						}
					}
				},
				emphasis: {
					focus: 'series'
				},
				data: [10, 18, 25, 40, 20, 10, 25, 15, 20, 50, 18, 30, 20, 10, 20, 40, 20, 10, 20, 11],
			}
		]
	}
	myChart.setOption(option);
}

function charts_init(){
	set_user_bar();
	cpu_bar();
	$('.sys-chart').width($('.main-content').width());
	
	$.ajax({
		type: 'POST',
		url: '',
		data: {
			
		},
		success: function(d) {
			if (d.ret != 0) return;
			
		}
	});
}
charts_init();
