function dateFormatter(data, type, row, meta) {
	return $.myTime.UnixToStrDate(data, true);
}

function ipFormatter(data, type, row, meta) {
	return _int2iP(data);
}

function editroletoken(role_id, name)
{
	showAjaxModal('edit_token', {
		content:{
			ajax: {
				url: 'modal.php?r=role@token',
			}
		},
		options:{
			data: {
				data: {
					role_id: role_id,
					name: name
				},
				success: function(e, d, msg){
					$tblist.role_mgd.ajax.reload();
				}
			}
		}
	}, true, 'modal-bgcolor modal-effect-16');
}

function refresh_package(db)
{
	var i, d = [];
//	db = $tblist.package.data();

	for(var i = 0; i < db.length; i++) {
		d.push(db[i].user_id);
	}

	$.ajax({
		url: 'api.php?r=package@getrole',
		data: {uids: d},
		success: function (data){
			if(data.ret != 0) return;

			var i, key, tb = {};
			for (i = 0; i < data.data.length; i++) {
				key = 'op' + data.data[i].user_id;
				if(typeof(tb[key]) != "object") tb[key] = {id: data.data[i].user_id, list:[]};
				tb[key].list.push('<a href=\'javascript:editroletoken('+data.data[i].role_id+', "'+data.data[i].name+'");\'>' + data.data[i].name + '</a>');
			}

			$('.card-package table td>span').html('');
			for (key in tb) {
				$(tb[key].list.join('，')).appendTo($('.card-package table .user_role_table_' + tb[key].id));
			}
		}
	});
}

var $tblist = {
	package: null,
	presale_card: null,
	presale_item: null,
	presale_logger: null
};

function package_init()
{
	$tblist.package = $('.card-package table').DataTable($.extend(true,{},OPTIONS_CONSTANT.DATA_TABLES.DEFAULT_OPTION, {
		pageLength: 50,
		displayLength: 20,
		dom: "<'row'><'row be-datatable-body'<'table-responsive'tr>><'row be-datatable-footer'<'col-sm-5'i><'col-sm-7'p>>",
		columns: [
			{
				title: '索引',
				data: 'index_js_id',
				width: 30,
				searchable: false,
				orderable: false,
				render: function(data, type, row, meta) {
					return meta.row + 1;
				}
			},
			{
				title: '账号',
				data: "name",
				width: 120
			},{
				title: '事件',
				data: "name",
				width: 120
			},{
				title: '登录时间',
				data: "name",
				width: 120
			},{
				title: '时长',
				data: "name",
				width: 120
			},
			{
				title: 'IP地址',
				data: "expense",
				width: 140,
			},
			{
				title: 'MAC地址',
				data: "count",
			},
			{
				title: '上行流量',
				data: "create_time",
				width: 120,
				render: dateFormatter
			},
			{
				title: '下行流量',
				data: "create_time",
				width: 120,
				render: dateFormatter
			}],
		createdRow: function( row, data, dataIndex ) {
			var id = getURL_val('id');
			if ( data.enable == 0)
				$(row).addClass('row-disabled');
		},
		fnDrawCallback: function (data) {
			$(":checkbox[name='cb-check-all']").prop('checked', false);
			// 默认选中第一行
			$("tbody tr", $tblist.package).eq(0).click();
			
			//if(data.json.ret == 0 && data.json.data.length > 0)
			//	refresh_package(data.json.data);
		},
		footerCallback: function (row, data, start, end, display ) {
			var api = this.api(), data;
			// Remove the formatting to get integer data for summation
			var intVal = function ( i ) {
				return typeof i === 'string' ?
					i.replace(/[\$,]/g, '')*1 :
					typeof i === 'number' ?
						i : 0;
			};
		},
		ajax: $.extend(true, {}, OPTIONS_CONSTANT.DATA_TABLES.AJAX, {
			url: 'api.php?r=package@list',
			data: function (d) {
				var search = $.trim($('#package .search_val').val());

				if(search != '') d.search.value = search;

				return $.extend({}, d, {
					extra_search: $('#package .extra').val()
				});
			}
		})
	})).on('xhr.dt', function ( e, settings, json, xhr ) {
		// Note no return - manipulate the data directly in the JSON object.
	})

	$('.card-package .search_btn').click(function(){
		$tblist.package.draw();
	});
}

function tabselect(id, reload)
{
	if(typeof $tblist[id] != "object") return;
	$('.tab-card-item .card-table').removeClass('show');

	if($tblist[id] == null) {
		if(id == 'package') package_init();
	}
	else
	if (reload) $tblist[id].ajax.reload();

	$('.tab-card-item.card-' + id + ' .card-table').addClass('show');
}

$(document).ready(function(){
	App.init();

	$(".datetimepicker").datetimepicker(OPTIONS_CONSTANT.DATA_DATETIMEPICKER);

	$('.nav-tabs a').on('click', function(){
		tabselect($(this).attr('href').substr(1), true);
	});

	if($('.mgd-tab').length > 0)
		tabselect($('.mgd-tab').eq(0).attr('id'), true);
	else
		tabselect('package', true);

	$(".reg-btn").click(function(){
		var e = $(this).parents('.tab-pane');
		var id = e.attr('id');
		showAjaxModal('create_' + id, {
			content:{
				ajax: {
					url: 'modal.php?r='+id+'@create',
				}
			},
			options:{
				data: {
					success: function(e, d, msg) {
						$tblist[id].ajax.reload();
					}
				}
			}
		}, true, 'modal-bgcolor modal-effect-16');
	});

	$('.search_btn').click(function(){
		var e = $(this).parents('.tab-pane');
		var id = e.attr('id');
		$tblist[id].draw();
	});

});
