<?php
namespace raas\apps\relayldap;


function _info(int $ent_id, int $own_id = 0)
{
	global $nidb;

	$sql = "select * from cloud_relay_ldap where `ent_id` = ?";

	try {
		if($own_id > 0) $sql .= " and `own_id` = ?";
		$sth = $nidb->prepare($sql);

		$index = 1;
		$sth->bindParam($index++, $ent_id, \PDO::PARAM_INT);
		if($own_id > 0) 
			$sth->bindParam($index++, $own_id, \PDO::PARAM_INT);
		
		$sth->execute();
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	if(count($rows) <= 0) {
		set_errmsg(MSG_LEVEL_DEF, __function__, "无效的记录。");
		return false;
	}
	
	return $rows[0];
}

function info($data)
{
	global $nidb;

	$optional = array();

	// set custom options
	if(format_and_push($data, 'ent_id', $optional, '', 'int', false) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, 'err: ent_id can\'t empty.');
		return false;
	}
	if(format_and_push($data, 'own_id', $optional, '', 'int', false)) 
		return _info($optional['ent_id'], $optional['own_id']);

	return _info($optional['ent_id']);
}

