<?php
namespace raas\apps\relayldap;

function remove($data)
{
	global $nidb;

	$filter = array(
		'own_id'	=> new \FilterVarID(true),
		'ent_id'	=> new \FilterVarID(true)
	);
	if(($where = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}

//	$nidb->beginTransaction();

	$frmData = array(
		'disabled' => TB_ROW_DEL_VALUE,
		'update_time' => time()
	);
	try {
		if(update_data('cloud_relay_ldap', $frmData, $where) === false) {
			$errmsg = implode(' ', $nidb->errorInfo());
			set_errmsg(MSG_LEVEL_DEF, __function__, $errmsg);
			return false;
		}
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}
//	$nidb->commit();

	raaseye_ent_relayldap_reload(0);

	return true;
}

