<?php
namespace raas\apps\relayldap;


// `own_id`, `ent_id`, `tls`, `host`, `port`, `basedn`, `binddn`, `passwd`
function create($data)
{
	global $nidb, $user;

	$filter = array(
		'own_id'	=> new \FilterVarID(true),
		'ent_id'	=> new \FilterVarID(true),
		'tls'		=> new \FilterVarInt(true),
		'disabled'	=> new \FilterVarInt(true),
		'host'		=> new \FilterVarStr(true),
		'port'		=> new \FilterVarInt(true),
		'basedn'	=> new \FilterVarStr(true),
		'binddn'	=> new \FilterVarStr(true),
		'passwd'	=> new \FilterVarStr(true)
	);

	if(($frmData = filter_data($data, $filter, $errmsg)) === false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, $errmsg);
		return false;
	}

	
	if(is_ipaddr($frmData['host']) == false) {
		set_errmsg(MSG_LEVEL_ARG, __function__, 'IP地址格式无效。');
		return false;
	}
	
	$sql = "insert into `cloud_relay_ldap`";
	$sql.= " (`own_id`, `ent_id`, `tls`, `host`, `port`, `basedn`, `binddn`, `passwd`, `update_time`, `create_time`, `disabled`)";
	$sql.= " values (?,?,?,?,?,?,?,?,?,?,?)";
	$sql.= " on duplicate key update";
	$sql.= " `tls` = ?, `host` = ?, `port` = ?, `basedn` = ?, `binddn` = ?, `passwd` = ?, `update_time` = ?, disabled = ?";

	$now = time();
	$values = array();
	array_push($values, $frmData['own_id']);
	array_push($values, $frmData['ent_id']);
	array_push($values, $frmData['tls']);
	array_push($values, $frmData['host']);
	array_push($values, $frmData['port']);
	array_push($values, $frmData['basedn']);
	array_push($values, $frmData['binddn']);
	array_push($values, $frmData['passwd']);
	array_push($values, $now);
	array_push($values, $now);
	array_push($values, $frmData['disabled']);
	
	array_push($values, $frmData['tls']);
	array_push($values, $frmData['host']);
	array_push($values, $frmData['port']);
	array_push($values, $frmData['basedn']);
	array_push($values, $frmData['binddn']);
	array_push($values, $frmData['passwd']);
	array_push($values, $now);
	array_push($values, $frmData['disabled']);

	$nidb->prepare($sql)->execute($values);

	raaseye_ent_relayldap_reload(0);

	return $frmData;
}
