<?php
if(PHP_SAPI != 'cli') exit;

function entowner_group_count_inc($own_id, $count)
{
	global $nidb;

	$sql = "update cloud_entowner
			set `groupcnt` = `groupcnt` + ?
			where `own_id` = ?";

	try {
		$sth = $nidb->prepare($sql);
		
		$index = 1;
		$sth->bindParam($index++, $count, \PDO::PARAM_INT);
		$sth->bindParam($index++, $own_id, \PDO::PARAM_INT);
		
		$sth->execute();
		return $sth->rowCount();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
	}
	
	return false;
}


function entowner_acct_count_inc($own_id, $count)
{
	global $nidb;

	$sql = "update cloud_entowner
			set `acctcnt` = `acctcnt` + ?
			where `own_id` = ?";

	try {
		$sth = $nidb->prepare($sql);
		
		$index = 1;
		$sth->bindParam($index++, $count, \PDO::PARAM_INT);
		$sth->bindParam($index++, $own_id, \PDO::PARAM_INT);
		
		$sth->execute();
		return $sth->rowCount();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage()); 
	}
	
	return false;
}

function ent_group_count_inc($ent_id, $count)
{
	global $nidb;

	$sql = "update cloud_enterpise
			set `groupcnt` = `groupcnt` + ?
			where `ent_id` = ?";

	try {
		$sth = $nidb->prepare($sql);
		
		$index = 1;
		$sth->bindParam($index++, $count, \PDO::PARAM_INT);
		$sth->bindParam($index++, $ent_id, \PDO::PARAM_INT);
		
		$sth->execute();
		return $sth->rowCount();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
	}
	
	return false;
}

function ent_acct_count_inc($ent_id, $count)
{
	global $nidb;

	$sql = "update cloud_enterpise
			set `acctcnt` = `acctcnt` + ?
			where `ent_id` = ?";

	try {
		$sth = $nidb->prepare($sql);
		
		$index = 1;
		$sth->bindParam($index++, $count, \PDO::PARAM_INT);
		$sth->bindParam($index++, $ent_id, \PDO::PARAM_INT);
		
		$sth->execute();
		return $sth->rowCount();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage()); 
	}
	
	return false;
}

function grp_acct_count_inc($group_id, $count)
{
	global $nidb;

	$sql = "update cloud_group
			set `acctcnt` = `acctcnt` + ?
			where `group_id` = ?";

	$sth = $nidb->prepare($sql);
	
	$index = 1;
	$sth->bindParam($index++, $count, \PDO::PARAM_INT);
	$sth->bindParam($index++, $group_id, \PDO::PARAM_INT);
	
	$sth->execute();
	return $sth->rowCount();
}

function ldap_sync_acct($own_id, $ent_id, $acctstrs, $accts)
{
	global $nidb;

	$acctpads = '?';
	if(count($acctstrs) > 1)
		$acctpads.= str_repeat(',?', count($acctstrs) - 1);

	$sql = "select `acct_id`, `account` from cloud_account";
	$sql.= " where `disabled` < " . TB_ROW_DEL_VALUE;
	$sql.= " and `ent_id` = {$ent_id} and `account` in ({$acctpads})";
	try {
		$sth = $nidb->prepare($sql);
		$sth->execute($acctstrs);
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	try {
		$curtm = time();
		$acctarray = array();
		foreach($rows as $data) {
			$acctarray[$data->account] = $data->acct_id;
		}

		$map = 'abcdefghijklmnopqrstuvwxyz1234567890';
		$l = strlen($map) - 1;
		
		$addcount = 0;
		$nidb->beginTransaction();
		foreach($accts as $acct) {
			$account = $acct['account'];
			if(isset($acctarray[$account])) {
				$setarray = array();
				$setstr = array();
				if($acct['phone'] != '`phone`') {
					array_push($setarray, $acct['phone']);
					array_push($setstr, '`phone` = ?');
				}
				if($acct['email'] != '`email`') {
					array_push($setarray, $acct['email']);
					array_push($setstr, '`email` = ?');
				}

				if(count($setarray) <= 0) 
					continue;

				array_push($setarray, $curtm);
				array_push($setstr, '`update_time` = ?');

				$sql = "update cloud_account set " . implode(',', $setstr);
				$sql.= " where `acct_id` = {$acctarray[$account]}";
				$sth = $nidb->prepare($sql);
				$sth->execute($setarray);
			}
			else {
				if($acct['phone'] == '`phone`')
					$acct['phone'] = '';
				if($acct['email'] == '`email`')
					$acct['email'] = '';
		
				$nc = 8;
				$pass = '';
				while($nc-- > 0) $pass .= $map{mt_rand(0, $l)};
			
				$sql = "insert into cloud_account";
				$sql.= " (`own_id`,`ent_id`,`group_id`,`account`,`name`,`phone`,`email`,`update_time`,`create_time`,`pass`,`group`)"; 
				$sql.= " value (?,?,?,?,?,?,?,?,?,?,?)";

				$sth = $nidb->prepare($sql);
				$sth->bindParam(1, $own_id, \PDO::PARAM_INT);
				$sth->bindParam(2, $ent_id, \PDO::PARAM_INT);
				$sth->bindParam(3, $acct['group_id'], \PDO::PARAM_INT);
				$sth->bindParam(4, $account, \PDO::PARAM_STR);
				$sth->bindParam(5, $account, \PDO::PARAM_STR);
				$sth->bindParam(6, $acct['phone'], \PDO::PARAM_STR);
				$sth->bindParam(7, $acct['email'], \PDO::PARAM_STR);
				$sth->bindParam(8, $curtm, \PDO::PARAM_INT);
				$sth->bindParam(9, $curtm, \PDO::PARAM_INT);
				$sth->bindParam(10, $pass, \PDO::PARAM_STR);
				$sth->bindParam(11, $acct['group'], \PDO::PARAM_STR);

					
				if($sth->execute()) {
					$addcount++;
					$acct_id = $nidb->lastInsertId();
					grp_acct_count_inc($acct['group_id'], 1);
					raaseye_acct_add(array(
						'acct_id'	=> $acct_id,
						'group_id'	=> $acct['group_id'],
						'ent_id'	=> $ent_id,
						'account'	=> $account,
						'pass'		=> $pass,
						'disabled'	=> 0,
						'maxcnt'	=> 0,
						'create_time'=> $curtm,
						'start_time'=> 0,
						'expire_time'=> 0,
						// 'bind_v4mac'=> 'bindmac',
						// 'bind_ipv4'	=> 'bindip',
						'bind_vlan'	=> 0,
						'pxyvlan_in'=> 0,
						'pxyvlan_out'=> 0,
						'pxyacct'	=> '',
						'pxypass'	=> '',
						'name'		=> $account,
						// 'idcard'	=> '',
						'rate_out'	=> 0,
						'rate_in'	=> 0,
					));
				}
			}
		}

		if($addcount) {
			ent_acct_count_inc($ent_id, $addcount);
			entowner_acct_count_inc($own_id, $addcount);
		}
		
		$nidb->commit();
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		$nidb->rollBack();
		return false;
	}
}


function ldap_sync_group($own_id, $ent_id, $ent_name, $grps)
{
	global $nidb;
	
	$grpsstr = '?';
	if(count($grps) > 1)
		$grpsstr.= str_repeat(',?', count($grps) - 1);

	$keys = array_values($grps);
	$sql = "select `group_id`,`parent_id`,`name` from cloud_group ";
	$sql.= "where `ent_id` = {$ent_id} and `disabled` < " . TB_ROW_DEL_VALUE;
	$sql.= " and `name` in ({$grpsstr})";
	try {
		$sth = $nidb->prepare($sql);
		$sth->execute($keys);
		$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		return false;
	}

	$garr = array();
	if($rows) {
		foreach($rows as $grp) {
			$garr[$grp->name] = array(
				'group_id'	=> $grp->group_id,
				'parent_id'	=> $grp->parent_id,
			);
		}
	}

	$curtm = time();
	$addcount = 0;
	$group_id = 0;
	$nidb->beginTransaction();
	try {
		foreach($grps as $name) {
			if(isset($garr[$name])) {
				if($garr[$name]['parent_id'] != $group_id) {
					$sql = "update cloud_group set `parent_id` = ?, `ent` = ? where `group_id` = ?";

					$sth = $nidb->prepare($sql);
					$sth->bindParam(1, $group_id, \PDO::PARAM_INT);
					$sth->bindParam(2, $garr[$name]['group_id'], \PDO::PARAM_INT);
					$sth->bindParam(3, $ent_name, \PDO::PARAM_STR);
					$sth->execute();
				}
			}
			else {
				$sql = "insert into cloud_group";
				$sql.= " (`own_id`, `ent_id`, `name`, `parent_id`,`update_time`,`create_time`,`ent`)";
				$sql.= " value (?,?,?,?,?,?,?)";

				$sth = $nidb->prepare($sql);
				$sth->bindParam(1, $own_id, \PDO::PARAM_INT);
				$sth->bindParam(2, $ent_id, \PDO::PARAM_INT);
				$sth->bindParam(3, $name, \PDO::PARAM_STR);
				$sth->bindParam(4, $group_id, \PDO::PARAM_INT);
				$sth->bindParam(5, $curtm, \PDO::PARAM_INT);
				$sth->bindParam(6, $curtm, \PDO::PARAM_INT);
				$sth->bindParam(7, $ent_name, \PDO::PARAM_STR);
				

				if($sth->execute()) {
					$addcount++;
					$garr[$name] = array (
						'parent_id' => $group_id,
						'group_id' => $nidb->lastInsertId()
					);
					raaseye_group_add(array(
						'group_id'	=> $garr[$name]['group_id'],
						'ent_id'	=> $ent_id,
						'name'		=> $name,
					//	'ifname'	=> '',
					//	'disabled' => 0,
					//	'clntepa'	=> 0,
					//	'startip'	=> '',
					//	'endip'		=> '',
					//	'rate_out'	=> '',
					//	'rate_in'	=> '',
					//	'dns0'		=> '',
					//	'dns1'		=> '',
					//	'maxonlinetm'=>'',
					//	'vlan_out'	=> '',
					//	'vlan_in'	=> '',
					));
				}
			}

			$group_id = $garr[$name]['group_id'];
		}
	}
	catch (\NiDBException $e) {
		set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
		$nidb->rollBack();
		return false;
	}
	if($addcount) {
		entowner_group_count_inc($own_id, $addcount);
		ent_group_count_inc($ent_id, $addcount);
	}
	
	$nidb->commit();
		
	return $group_id;
}

function ldap_sync_ent($ldap)
{
	// Connecting to LDAP
	$ldapconn = ldap_connect($ldap->host, $ldap->port);
	if($ldapconn === false) {
		echo "Could not connect to {$ldap->host}\n";
		return false;
	}

	// ldap rdn or dn
	$ldaprdn  = $ldap->binddn; // "CN=Administrator,CN=Users,DC=webauth,DC=panabit,DC=com";
	$ldappass = $ldap->passwd; // associated password

	if($ldapconn) {
		ldap_set_option($ldapconn, LDAP_OPT_PROTOCOL_VERSION, 3);
		// binding to ldap server
		$ldapbind = ldap_bind($ldapconn, $ldaprdn, $ldappass);
		if (!$ldapbind) {
			echo "LDAP bind failed...\n";
			return false;
		}

		$res = ldap_search($ldapconn, $ldap->basedn, "(objectClass=user)");
		if (!ldap_count_entries($ldapconn, $res))
			return false;

		$accts = array();
		$acctstrs = array();
		$group_id = 0;
		$basedn_len = strpos($ldap->basedn, ',');
		if($basedn_len === false)
			$basedn_len = strlen($ldap->basedn);
		else
			$basedn_len = strlen($ldap->basedn) - $basedn_len - 1;

		for ($ent=ldap_first_entry($ldapconn,$res); $ent; $ent=ldap_next_entry($ldapconn, $ent)) {
			list($dn) = ldap_get_values_len($ldapconn, $ent, 'distinguishedName');
//			if(in_array('organizationalPerson', $objectClass)) {
			// create group
			if(($pos = strpos($dn, ',')) === false)
				continue;

			$user = '';
			$groupstr = substr($dn, $pos + 1);
			if($lastgrp != $groupstr) {
				$dn = substr($dn, 0, strlen($dn) - $basedn_len - 1);
				$dns = explode(',', $dn);
				if(count($dns) < 2)
					continue;

				// CN=IT,CN=Users
				// 倒序将组织同步到数据库
				$groups = array();
				for($i = count($dns) - 1; $i >= 0; $i--) {
					$nodes = explode('=', $dns[$i]);
					if(count($nodes) == 2) {
						array_push($groups, $nodes[1]);
						$user = $nodes[1];
					}
				}
				if(count($groups) > 1) {
					array_pop($groups);
					$group_id = ldap_sync_group($ldap->own_id, $ldap->ent_id, $ldap->name, $groups);
				}
				$lastgrp = $groupstr;
			}

			if($user != '' && $group_id > 0) {
				$acct = array(
					'account'	=> $user,
					'account'	=> $user,
					'group_id'	=> $group_id,
					'phone'		=> '`phone`',
					'email'		=> '`email`',
					'group'		=> $groups[count($groups) - 1],
				);
				list($mail) = ldap_get_values_len($ldapconn, $ent, 'mail');
				if(isset($mail))
					$acct['email'] = $mail;
				list($phone) = ldap_get_values_len($ldapconn, $ent, 'telephoneNumber');
				if(isset($phone))
					$acct['phone'] = $phone;
				
				array_push($acctstrs, $user);
				array_push($accts, $acct);

				if(count($acctstrs) > 50) {
					ldap_sync_acct($ldap->own_id, $ldap->ent_id, $acctstrs, $accts);
					$accts = array();
					$acctstrs = array();
				}
			}
//			}
		}

		if(count($acctstrs) > 0)
			ldap_sync_acct($ldap->own_id, $ldap->ent_id, $acctstrs, $accts);

		ldap_close($ldapconn);
	}
}

function ldap_sync_start()
{
	global $nidb;


//	$time = time(NULL) - 180;

	$sql = "select r.`own_id`, r.`ent_id`, e.`name`, r.`tls`, r.`host`, r.`port`, r.`basedn`, r.`binddn`, r.`passwd`";
	$sql.= " from cloud_relay_ldap as r";
	$sql.= " inner join cloud_enterpise e";
	$sql.= " on r.`ent_id` = e.`ent_id`";
	$sql.= " where r.`host` != '' and r.`port` > 0 and r.`basedn` != ''";
	$sql.= " and r.`disabled` = 0 and e.`disabled` = 0";
	$sql.= " and r.`binddn` != ''"; // and r.`sync_time` < {$time}";
	$sth = $nidb->prepare($sql);
	$sth->execute();
	$ents = $sth->fetchAll(PDO::FETCH_CLASS);

	if($ents && count($ents)) {
		$ldapid = array();
		foreach($ents as $cfg) {
			if(ldap_sync_ent($cfg))
				array_push($ldapid, $cfg->ent_id);
		}
			
		if(count($ldapid) > 0) {
			try {
				$sql = "update cloud_relay_ldap set `sync_time` = ? where `ent_id` in (" . implode(',', $ldapid) . ")";

				$curtm = time();
				$sth = $nidb->prepare($sql);
				$sth->bindParam(1, $curtm, \PDO::PARAM_INT);
				$sth->execute();
			}
			catch (\NiDBException $e) {
				set_errmsg(MSG_LEVEL_EXP, __function__, $e->getMessage());
				return false;
			}
		}
	}

	return true;
}

ldap_sync_start();

/*

$ldapcfg = myconf_read($fldapcfg, array());
if(isset($ldapcfg['tls']) == false)
	$ldapcfg['tls'] = 0;
else
	$ldapcfg['tls'] = intval($ldapcfg['tls']);
if(isset($ldapcfg['host']) == false
|| empty($ldapcfg['host'])) {
	echo "host empty.\n";
	exit;
}
if(isset($ldapcfg['port']) == false) {
	if($ldapcfg['tls'])
		$ldapcfg['port'] = 636;
	else
		$ldapcfg['port'] = 389;
}
else
	$ldapcfg['port'] = intval($ldapcfg['port']);
if(isset($ldapcfg['basedn']) == false 
|| empty($ldapcfg['basedn'])) {
	echo "basedn empty.\n";
	exit;
}
if(isset($ldapcfg['binddn']) == false 
|| empty($ldapcfg['binddn'])) {
	echo "binddn empty.\n";
	exit;
}
if(isset($ldapcfg['passwd']) == false) {
	$ldapcfg['passwd'] = '';
}

$ldapsearch = '/usr/paraas/bin/ldapsearch';
$fldapcfg = '/usr/paraas/etc/ldapcfg.conf';
if(!is_file($ldapsearch) || !is_file($fldapcfg))
	exit;
if(!is_executable($ldapsearch))
	exit;

function myconf_read($file, $data = array())
{
	$ret = array();
	
	if(is_array($data) == false)
		$data = array();

	if (!file_exists($file)) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '配置文件不存在！' . $file);
		return $ret;
	}

	if ($fp = fopen($file, "r")) {
		$cnt = 0;
		$keycnt = count($data);
		while (!feof($fp)) {
			if(($buf = fgets($fp)) === false)
				break;
			if(empty($buf = trim($buf)))
				continue;

			$col = explode('=', $buf, 2);
			if(count($col) != 2)
				continue;
			$key = trim($col[0]);
			if(strpos($key, ' ') !== false)
				continue;

			if($keycnt && in_array($key, $data) == false)
				continue;

			$ret[$key] = trim($col[1]);
			$cnt++;
			if($cnt == $keycnt) break;
		}
		fclose($fp);
	}
	else
		set_errmsg(MSG_LEVEL_DEF, __function__, '配置文件打开失败！' . $file);
		
	return $ret;
}

$time = time(NULL) - 60;

$sql = "select `own_id`, `ent_id`, `tls`, `host`, `port`, `basedn`, `binddn`, `passwd` ";
$sql.= " from cloud_enterpise_ldapacct_map where `host` != '' and `port` > 0 and `basedn` != '' and `binddn` != '' and `update_time` < {$time} order by `update_time`";
$sth = $nidb->prepare($sql);
$sth->execute();
$ents = $sth->fetchAll(PDO::FETCH_CLASS);

if($ents) {
	$frmData = array();
	$where = array();
	foreach($ents as $cfg) {

		foreach($rows as $grp) {
			ldap_sync($cfg);
			
			$cmd = "{$ldapsearch} -h {$cfg->host} -p {$cfg->port} -b \"{$grp->basedn}\" -D \"{$cfg->binddn}\" -w \"{$cfg->passwd}\" -LLL \"(objectclass=user)\" CN DN sAMAccountName telephoneNumber mail";
			exec($cmd, $out, $ret);
			if($ret) {
				echo "err: " . implode(' ', $out) . "\n";
				continue;
			}

			$accts = array();
			$acct = '';
			$row = '';
			$fp = popen($cmd, "r");
			while (!feof($fp)) {
				if(($buf = fgets($fp, 512)) === false)
					break;
				if(($pos = strpos($buf, ':')) === false)
					continue;
				else {
					$key = substr($buf, 0, $pos);
					if($key == 'dn') {
						if(($pos = strpos($row, ',')) === false)
							continue;
						if(count($accts) >= 50) {
							sync_acct($cfg['ent_id'], $accts);
							$accts = array();
						}
						$acct = substr($row, 7, $pos);
						$acct = array(
							'phone'	=> '`phone`',
							'email'	=> '`email`',
						);
						$accts[$acct] = array(
							'phone'	=> '`phone`',
							'email'	=> '`email`',
						);
					}
					else
					if($acct != '' && $key == 'telephoneNumber') {
						$accts[$acct]['phone'] = trim(substr($row, $pos + 1));
					}
					else
					if($acct != '' && $key == 'mail') {
						$accts[$acct]['email'] = trim(substr($row, $pos + 1));
					}
				}
			}
			pclose($fp);
			if(count($accts) > 0) {
				sync_acct($cfg['ent_id'], $accts);
			}
		}
	}
}
*/
