<?php

$nidb->setAttribute(\PDO::ATTR_ERRMODE, \PDO::ERRMODE_WARNING);


// 2020-11-25 包峰源，学校需求认证帐号可以通过email找回密码。
$sql = "
ALTER TABLE `cloud_account`
ADD COLUMN `email`  varchar(48) NOT NULL DEFAULT '' COMMENT '联系邮箱' AFTER `phone`,
ADD COLUMN `forgotcnt`  int(11) NOT NULL DEFAULT 0 COMMENT '找回密码次数' AFTER `iwacct_id`,
ADD COLUMN `wxopenid`  varchar(64) NOT NULL DEFAULT '' COMMENT '微信OPENID，扫码登陆。' AFTER `email`;
";
$nidb->query($sql);

$sql = "
ALTER TABLE `cloud_account`
MODIFY COLUMN `email`  varchar(48) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' COMMENT '联系邮箱' AFTER `phone`;
";
$nidb->query($sql);


// 2021-07-12 根据IP去查询账号使用。
$sql = "
ALTER TABLE `cloud_account`
ADD COLUMN `lastip`  varchar(16) NOT NULL DEFAULT '' COMMENT '最后使用的IP。' AFTER `expire_time`;
";
$nidb->query($sql);

// 2021-08-17 根据最认证时的时间去查询账号的帐号使用情况。
$sql = "
ALTER TABLE `cloud_account`
ADD COLUMN `lasttm` bigint NOT NULL DEFAULT '0' COMMENT '最后登陆IP' AFTER `expire_time`;
";
$nidb->query($sql);


// 2021-05-07 增加地址池，用于对接PA，多运营商接入认证。
$sql = "
ALTER TABLE `cloud_account`
ADD COLUMN `ippool` char(32) NOT NULL DEFAULT '' COMMENT 'PA地址池名称' AFTER `webuser_id`;
";
$nidb->query($sql);

// 2021-03-19 增加自助帐号登陆时间、登陆IP记录
$sql = "
ALTER TABLE `cloud_account`
ADD COLUMN `lastlogin_time`  bigint(20) NOT NULL DEFAULT '0' COMMENT '最后登陆时间' AFTER `rate_in`,
ADD COLUMN `lastlogin_ip`  int(11) NOT NULL DEFAULT '0' COMMENT '最后登陆IP' AFTER `lastlogin_time`;
";
$nidb->query($sql);


// 2021-07-26 增加运营商AAA认证支持
$sql = "
ALTER TABLE `cloud_account`
ADD COLUMN `isp_id`  int(11) UNSIGNED NOT NULL DEFAULT '0' COMMENT '当前选中AAA运营商ID' AFTER `webuser_id`;
";
$nidb->query($sql);


// 2021-02-04 柳州技术陈斌，机电工业学校认证测试对接
// 下面是全局配置表，增加同步数据库功能，key=account_lastupdate，val=同步时间
// 当同步时间发生变化时，paraas会重新扫描认证帐号表中“update_time”大于等于“同步时间”的帐号记录更新。
$sql = "
CREATE TABLE IF NOT EXISTS `cloud_config` (
  `key` varchar(128) NOT NULL DEFAULT '' COMMENT '键名',
  `val` varchar(255) NOT NULL DEFAULT '' COMMENT '键值',
  PRIMARY KEY (`key`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
";
$nidb->query($sql);


// 2021-03-19 李腾飞建议，将用户登陆日志写入数据库，方便查询。
$sql = "
CREATE TABLE IF NOT EXISTS `cloud_account_loginlog` (
  `own_id` int(11) NOT NULL DEFAULT '0' COMMENT '所有者ID',
  `ent_id` int(11) NOT NULL DEFAULT '0' COMMENT '企业ID',
  `group_id` int(11) NOT NULL DEFAULT '0' COMMENT '用户组ID',
  `acct_id` int(11) NOT NULL DEFAULT '0' COMMENT '用户ID',
  `ip`  int(11) NOT NULL DEFAULT '0' COMMENT '最后登陆IP',
  `account` char(30) NOT NULL DEFAULT '' COMMENT '帐号',
  `name` char(32) NOT NULL DEFAULT '' COMMENT '姓名',
  `event` char(32) NOT NULL DEFAULT '' COMMENT '事件',
  `result` tinyint(4) UNSIGNED NOT NULL DEFAULT 0 COMMENT '事件结果：0：无结果，1：成功；2：失败',
  `remark` varchar(255) NOT NULL DEFAULT ''COMMENT '备注',
  `create_time` bigint(20) NOT NULL DEFAULT '0' COMMENT '创建时间'
) ENGINE=ARCHIVE DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT;
";
$nidb->query($sql);


// 2021-04-29 增加多运营商的分类配置，支持多个运营商接入代拨使用。
$sql = "
CREATE TABLE IF NOT EXISTS `cloud_account_isp` (
  `acct_id` int(11) NOT NULL DEFAULT '0' COMMENT '用户ID',
  `isp_id` int(11) NOT NULL DEFAULT '0' COMMENT 'ISP ID',
  `own_id` int(11) NOT NULL DEFAULT '0' COMMENT '归属所有者ID',
  `disabled` tinyint(4) NOT NULL DEFAULT '0' COMMENT '是否禁用',
  `acct` char(32) NOT NULL DEFAULT '' COMMENT '帐号',
  `pass` char(32) NOT NULL DEFAULT '' COMMENT '密码',
  `vlan_in` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '代拨内层vlan',
  `vlan_out` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '代拨外层vlan',
  `update_time` bigint(20) NOT NULL DEFAULT '0' COMMENT '最后更新时间',
  `create_time` bigint(20) NOT NULL DEFAULT '0' COMMENT '创建时间',
  PRIMARY KEY (`isp_id`, `acct_id`, `acct`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
";
$nidb->query($sql);

// 2021-05-19 增加帐号的使用日志。
// `ret` tinyint(4) NOT NULL DEFAULT '0' COMMENT '事件结果：0：未知，1：成功，2：失败',
$sql = "
CREATE TABLE IF NOT EXISTS `cloud_account_usage_logger` (
  `own_id` int(11) NOT NULL DEFAULT '0' COMMENT '所有者ID',
  `ent_id` int(11) NOT NULL DEFAULT '0' COMMENT '企业ID',
  `group_id` int(11) NOT NULL DEFAULT '0' COMMENT '用户组ID',
  `acct_id` int(11) NOT NULL DEFAULT '0' COMMENT '用户ID',
  `event` varchar(16) NOT NULL DEFAULT '' COMMENT '事件',
  `ip`  int(11) NOT NULL DEFAULT '0' COMMENT '最后登陆IP',
  `mac`  varchar(18) NOT NULL DEFAULT '' COMMENT '最后登陆MAC',
  `session_id`  varchar(38) NOT NULL DEFAULT '' COMMENT '会话ID',
  `account` varchar(74) NOT NULL DEFAULT '' COMMENT '帐号',
  `name` varchar(32) NOT NULL DEFAULT '' COMMENT '用户名',
  `ent` varchar(96) NOT NULL DEFAULT '' COMMENT '归属企业',
  `gorup` varchar(16) NOT NULL DEFAULT '' COMMENT '归属组',
  `tmlong` int(11) NOT NULL DEFAULT '0' COMMENT '会话时长',
  `event_time` bigint(20) NOT NULL DEFAULT '0' COMMENT '会话产生时间',
  `bpsin` bigint(20) NOT NULL DEFAULT '0' COMMENT '上行流量',
  `bpsout` bigint(20) NOT NULL DEFAULT '0' COMMENT '下行流量',
  `create_time` bigint(20) NOT NULL DEFAULT '0' COMMENT '记录创建时间'
) ENGINE=ARCHIVE DEFAULT CHARSET=utf8 COMMENT='帐号使用日志';
";
$nidb->query($sql);

// 2021-03-19 李腾飞建议，将用户认证日志写入数据库，方便查询。
/*
$sql = "
CREATE TABLE IF NOT EXISTS `cloud_account_authlog` (
  `own_id` int(11) NOT NULL DEFAULT '0' COMMENT '所有者ID',
  `ent_id` int(11) NOT NULL DEFAULT '0' COMMENT '企业ID',
  `group_id` int(11) NOT NULL DEFAULT '0' COMMENT '用户组ID',
  `acct_id` int(11) NOT NULL DEFAULT '0' COMMENT '用户ID',
  `ip`  int(11) NOT NULL DEFAULT '0' COMMENT '最后登陆IP',
  `mac`  char(18) NOT NULL DEFAULT '0' COMMENT '最后登陆MAC',
  `account` char(74) NOT NULL DEFAULT '' COMMENT '帐号',
  `event` char(32) NOT NULL DEFAULT '' COMMENT '事件',
  `create_time` bigint(20) NOT NULL DEFAULT '0' COMMENT '创建时间'
) ENGINE=ARCHIVE DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT;
";
$nidb->query($sql);
*/


// 2021-05-14 张颜峰华为ME60对接建议，将用户上下线日志写入数据库，方便查询。
/*
$sql = "
CREATE TABLE IF NOT EXISTS `cloud_account_login_logger` (
  `own_id` int(11) NOT NULL DEFAULT '0' COMMENT '所有者ID',
  `ent_id` int(11) NOT NULL DEFAULT '0' COMMENT '企业ID',
  `group_id` int(11) NOT NULL DEFAULT '0' COMMENT '用户组ID',
  `acct_id` int(11) NOT NULL DEFAULT '0' COMMENT '用户ID',
  `ip`  int(11) NOT NULL DEFAULT '0' COMMENT '最后登陆IP',
  `account` char(30) NOT NULL DEFAULT '' COMMENT '帐号',
  `name` char(32) NOT NULL DEFAULT '' COMMENT '姓名',
  `event` char(32) NOT NULL DEFAULT '' COMMENT '事件',
  `create_time` bigint(20) NOT NULL DEFAULT '0' COMMENT '创建时间'
) ENGINE=ARCHIVE DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT;
";
$nidb->query($sql);
*/

// 2021-07-09 操作员修改帐号时记录操作日志。
$sql = "
CREATE TABLE IF NOT EXISTS `cloud_account_modify_logger` (
  `acctlog_id` int(11) NOT NULL AUTO_INCREMENT,
  `own_id` int(11) NOT NULL DEFAULT '0' COMMENT '归属所有者',
  `ent_id` int(11) NOT NULL DEFAULT '0' COMMENT '归属企业',
  `acct_id` int(11) NOT NULL DEFAULT '0' COMMENT '认证帐号ID',
  `user_id` int(11) NOT NULL DEFAULT '0' COMMENT '操作者ID',
  `account` char(30) NOT NULL DEFAULT '' COMMENT '帐号',
  `username` varchar(32) NOT NULL DEFAULT '' COMMENT '操作者名称',
  `oper_ip` varchar(40) NOT NULL DEFAULT '' COMMENT '操作时所在的IP',
  `action` varchar(32) NOT NULL DEFAULT '' COMMENT '动作',
  `data` text NOT NULL COMMENT '操作明细',
  `remark` varchar(256) NOT NULL DEFAULT '' COMMENT '备注',
  `create_time` bigint(20) NOT NULL DEFAULT '0' COMMENT '创建时间',
  PRIMARY KEY (`acctlog_id`)
) ENGINE=ARCHIVE DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT;
";
$nidb->query($sql);
