<?php

$nidb->setAttribute(\PDO::ATTR_ERRMODE, \PDO::ERRMODE_WARNING);

// 2020-11-25 包峰源，学校需求认证帐号可以通过email找回密码。
$sql = "
ALTER TABLE `cloud_enterpise`
ADD COLUMN `forgotcnt` int(11) NOT NULL DEFAULT '0' COMMENT '找回密码次数' AFTER `trafficnt`;
";
$nidb->query($sql);

// 2021-05-31 企业增加NAS验证
$sql = "
ALTER TABLE `cloud_enterpise`
ADD COLUMN `syncsrc` tinyint(4) NOT NULL DEFAULT '0' COMMENT '帐号的同步源：0：本地，1：LDAP；2：Radius' AFTER `disabled`;
";
$nidb->query($sql);

// 2021-08-15 增加MACTTL记忆超时时间。
$sql = "
ALTER TABLE `cloud_enterpise`
ADD COLUMN `macttl` int unsigned NOT NULL DEFAULT '0' COMMENT 'MAC记忆TTL超时时间' AFTER `name`;
";
$nidb->query($sql);


// 2021-04-29 增加多运营商的分类配置，支持多个运营商接入代拨使用。
$sql = "
CREATE TABLE IF NOT EXISTS `cloud_enterpise_isp` (
  `isp_id` int(11) NOT NULL AUTO_INCREMENT,
  `own_id` int(11) NOT NULL DEFAULT '0' COMMENT '归属所有者ID',
  `ent_id` int(11) NOT NULL DEFAULT '0' COMMENT '归属企业ID',
  `group_id` int(11) NOT NULL DEFAULT '0' COMMENT '归属用户组ID',
  `disabled` tinyint(4) NOT NULL DEFAULT '0' COMMENT '是否禁用',
  `ippool` char(32) NOT NULL DEFAULT '' COMMENT 'PA地址池名称',
  `vlan_in` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '代拨内层vlan',
  `vlan_out` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '代拨外层vlan',
  `name` char(32) NOT NULL DEFAULT '' COMMENT '名称',
  `pxy_type` tinyint(4) NOT NULL DEFAULT '0' COMMENT '代理类型',
  `lport` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '本地服务监听端口',
  `serip` char(32) NOT NULL DEFAULT '' COMMENT '代理服务器IP',
  `nas` char(36) NOT NULL DEFAULT '' COMMENT 'NAS名称',
  `secret` char(32) NOT NULL DEFAULT '' COMMENT '密钥',
  `access` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '认证端口',
  `accounting` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '计费端口',
  `coa` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'CoA端口',
  `remark` varchar(255) NOT NULL DEFAULT '' COMMENT '备注',
  `update_time` bigint(20) NOT NULL DEFAULT '0' COMMENT '最后更新时间',
  `create_time` bigint(20) NOT NULL DEFAULT '0' COMMENT '创建时间',
  PRIMARY KEY (`isp_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
";
$nidb->query($sql);


// 2021-05-07 增加地址池，用于对接PA，多运营商接入认证。
$sql = "
ALTER TABLE `cloud_enterpise_isp`
ADD COLUMN `ippool` char(32) NOT NULL DEFAULT '' COMMENT 'PA地址池名称' AFTER `disabled`;
";
$nidb->query($sql);


// 2021-08-06 增加地址池，用于对接PA，多运营商接入认证。
// 检查表中的access端口数据类型，并转成短正数型
$sql = "select column_name, column_type from information_schema.columns where table_schema ='panabit_raas' and table_name = 'cloud_enterpise_isp' and `column_name` = 'access'";
$sth = $nidb->prepare($sql);
$sth->execute();
$rows = $sth->fetchAll(\PDO::FETCH_CLASS);
if(count($rows) > 0 && strpos($rows[0]->COLUMN_TYPE, 'char') !== false) {
	// 2021-08-06 增加地址池，用于对接PA，多运营商接入认证。
	$sql = "
	ALTER TABLE `cloud_enterpise_isp`
	MODIFY COLUMN `access` smallint unsigned NOT NULL DEFAULT '0' COMMENT '认证端口' AFTER `secret`,
	MODIFY COLUMN `accounting` smallint unsigned NOT NULL DEFAULT '0' COMMENT '计费端口' AFTER `access`,
	MODIFY COLUMN `coa` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'CoA端口' AFTER `accounting`;
	";
	$nidb->query($sql);
}
else {
	$sql = "
	ALTER TABLE `cloud_enterpise_isp`
	ADD COLUMN `pxy_type` tinyint(4) NOT NULL DEFAULT '0' COMMENT '代理类型' AFTER `name`,
	ADD COLUMN `serip` char(32) NOT NULL DEFAULT '' COMMENT '代理服务器IP' AFTER `pxy_type`,
	ADD COLUMN `nas` char(36) NOT NULL DEFAULT '' COMMENT 'NAS名称' AFTER `serip`,
	ADD COLUMN `secret` char(32) NOT NULL DEFAULT '' COMMENT '密钥' AFTER `nas`,
	ADD COLUMN `access` smallint unsigned NOT NULL DEFAULT '0' COMMENT '认证端口' AFTER `secret`,
	ADD COLUMN `accounting` smallint unsigned NOT NULL DEFAULT '0' COMMENT '计费端口' AFTER `access`,
	ADD COLUMN `coa` smallint unsigned NOT NULL DEFAULT '0' COMMENT 'CoA端口' AFTER `accounting`;
	";
	$nidb->query($sql);
}

/*
// 2021-05-07 增加地址池，用于对接PA，多运营商接入认证。
$sql = "
ALTER TABLE `cloud_enterpise_isp`
ADD COLUMN `lport` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '本地服务监听端口' AFTER `pxy_type`;
";
$nidb->query($sql);
*/
// $nidb->setAttribute(\PDO::ATTR_ERRMODE,\PDO::ERRMODE_EXCEPTION);
