<?php
// ********************************************************
// function comm
// ********************************************************
function httpPost($url, $data, $verify = true)
{
	$post = '';
	foreach($data as $k => $v) 
		$post .= "&$k=$v";
	
	if($post != '')
		$post = ' --data "' . substr($post, 1) . '" ';
	
	if($verify)
		$cmd = '/usr/local/bin/curl -k --connect-timeout 10 --retry-max-time 10 --max-time 10' . $post . '"' . $url . '" 2>/dev/null';
	else
		$cmd = '/usr/local/bin/curl --connect-timeout 10 --retry-max-time 10 --max-time 10' . $post . '"' . $url . '" 2>/dev/null';

	$fp = popen($cmd, "r");
	$res = '';
	while (!feof($fp)) { 
		$buffer = fgets($fp, 4096); 
		$res .= $buffer;
	}
	pclose($fp);
	//return str_replace(PHP_EOL, '', $res);
	return $res;
}

function httpPostV2($url, $data, $verify = true)
{
	$curl = curl_init();
	curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($curl, CURLOPT_TIMEOUT, 500);
	//curl_setopt($curl, CURLOPT_SSLVERSION, 3); 
	curl_setopt($curl, CURLOPT_HEADER, false);
	curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, $verify);
	curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, $verify);
	curl_setopt($curl, CURLOPT_URL, $url);
	curl_setopt($curl, CURLOPT_POST, 1);
	curl_setopt($curl, CURLOPT_POSTFIELDS, $data);

	$res = curl_exec($curl);
	curl_close($curl);

	return $res;
}


function myconf_read($file, $data = array())
{
	$ret = array();
	
	if(is_array($data) == false)
		$data = array();

	if (!file_exists($file)) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '配置文件不存在！' . $file);
		return $ret;
	}

	if ($fp = fopen($file, "r")) {
		$cnt = 0;
		$keycnt = count($data);
		while (!feof($fp)) {
			if(($buf = fgets($fp)) === false)
				break;
			if(empty($buf = trim($buf)))
				continue;

			$col = explode('=', $buf, 2);
			if(count($col) != 2)
				continue;
			$key = trim($col[0]);
			if(strpos($key, ' ') !== false)
				continue;

			if($keycnt && in_array($key, $data) == false)
				continue;

			$ret[$key] = trim($col[1]);
			$cnt++;
			if($cnt == $keycnt) break;
		}
		fclose($fp);
	}
	else
		set_errmsg(MSG_LEVEL_DEF, __function__, '配置文件打开失败！' . $file);
		
	return $ret;
}

function myconf_save($file, $data = array())
{
	if(is_array($data) == false)
		$data = array();

	$ftmp = tempnam("/tmp", "myconf");
	if (!($fpw = fopen($ftmp, "w"))) {
		set_errmsg(MSG_LEVEL_DEF, __function__, '临时配置文件打开失败！' . $ftmp);
		return false;
	}

	if (file_exists($file)) {
		if ($fp = fopen($file, "r")) {
			$keys = array_keys($data);
			while (!feof($fp)) {
				if(($line = fgets($fp)) === false)
					break;
				if(empty($buf = trim($line, " \t\n\r\0\x0B"))) {
					fwrite($fpw, "\n");
					continue;
				}

				$col = explode('=', $buf, 2);
				if(count($col) != 2){
					fwrite($fpw, "{$buf}\n");
					continue;
				}
				
				$key = trim($col[0]);
				if(($id = array_search($key, $keys)) === false) {
					fwrite($fpw, "{$buf}\n");
					continue;
				}
				$val = trim($data[$key], " \t\n\r\0\x0B");
				fwrite($fpw, "{$key}={$val}\n");

				unset($keys[$id]);
				unset($data[$key]);
			}
			foreach($data as $key => $val) {
				$val = trim($val, " \t\n\r\0\x0B");
				fwrite($fpw, "{$key}={$val}\n");
			}
			fclose($fp);
		}
		else {
			fclose($fpw);
			unlink($ftmp);
			set_errmsg(MSG_LEVEL_DEF, __function__, '配置文件打开失败！' . $file);
			return false;
		}
	}
	else {
		foreach($data as $key => $val) {
			$val = trim($val, " \t\n\r\0\x0B");
			fwrite($fpw, "{$key}={$val}\n");
		}
	}

	fclose($fpw);

	if(rename($ftmp, $file))
		return true;

	unlink($ftmp);
	set_errmsg(MSG_LEVEL_DEF, __function__, '保存配置文件失败！' . $file);

	return false;
}
